#> iris_rempot:get_hitbox/block/offset
#
# Computes seeded block offset for e.g. flowers, assuming the shape comprises a single box
#
# @writes
#	storage iris_rempot:data Shape: compound[]
#       A list of cuboids given by two corners in the format {min: [x, y, z], max: [x, y z]}

# Compute seed(x, y, z)
scoreboard players operation $a iris_rempot = $[x] iris_rempot
scoreboard players operation $a iris_rempot *= $3129871 iris_rempot
scoreboard players operation $b iris_rempot = $[z] iris_rempot
scoreboard players operation $b iris_rempot *= $116129781 iris_rempot
execute store result score $a^b iris_rempot run function iris_rempot:get_hitbox/block/xor

scoreboard players operation $(a^b)² iris_rempot = $a^b iris_rempot
scoreboard players operation $(a^b)² iris_rempot *= $a^b iris_rempot
scoreboard players operation $11*(a^b) iris_rempot = $a^b iris_rempot
scoreboard players operation $11*(a^b) iris_rempot *= $11 iris_rempot

scoreboard players operation $seed iris_rempot = $(a^b)² iris_rempot
scoreboard players operation $seed iris_rempot *= $42317861 iris_rempot
scoreboard players operation $seed iris_rempot += $11*(a^b) iris_rempot
scoreboard players operation $seed iris_rempot /= $65536 iris_rempot

# Compute offsets
scoreboard players operation $x_offset iris_rempot = $seed iris_rempot
scoreboard players operation $x_offset iris_rempot %= $16 iris_rempot
scoreboard players operation $x_offset iris_rempot *= $33333 iris_rempot

scoreboard players operation $z_offset iris_rempot = $seed iris_rempot
scoreboard players operation $z_offset iris_rempot /= $256 iris_rempot
scoreboard players operation $z_offset iris_rempot %= $16 iris_rempot
scoreboard players operation $z_offset iris_rempot *= $33333 iris_rempot

# Adjust/clamp for pointed dripstone blocks
execute if block ~ ~ ~ minecraft:pointed_dripstone run scoreboard players remove $x_offset iris_rempot 125000
execute if block ~ ~ ~ minecraft:pointed_dripstone run scoreboard players remove $z_offset iris_rempot 125000
execute if block ~ ~ ~ minecraft:pointed_dripstone if score $x_offset iris_rempot matches ..0 run scoreboard players set $x_offset iris_rempot 0
execute if block ~ ~ ~ minecraft:pointed_dripstone if score $x_offset iris_rempot matches 250000.. run scoreboard players set $x_offset iris_rempot 250000
execute if block ~ ~ ~ minecraft:pointed_dripstone if score $z_offset iris_rempot matches ..0 run scoreboard players set $z_offset iris_rempot 0
execute if block ~ ~ ~ minecraft:pointed_dripstone if score $z_offset iris_rempot matches 250000.. run scoreboard players set $z_offset iris_rempot 250000

# Apply offsets to the generated shape
execute store result score $min_x iris_rempot run data get storage iris_rempot:data Shape[0].min[0] 1000000
execute store result storage iris_rempot:data Shape[0].min[0] double 0.000001 run scoreboard players operation $min_x iris_rempot += $x_offset iris_rempot
execute store result score $min_z iris_rempot run data get storage iris_rempot:data Shape[0].min[2] 1000000
execute store result storage iris_rempot:data Shape[0].min[2] double 0.000001 run scoreboard players operation $min_z iris_rempot += $z_offset iris_rempot
execute store result score $max_x iris_rempot run data get storage iris_rempot:data Shape[0].max[0] 1000000
execute store result storage iris_rempot:data Shape[0].max[0] double 0.000001 run scoreboard players operation $max_x iris_rempot += $x_offset iris_rempot
execute store result score $max_z iris_rempot run data get storage iris_rempot:data Shape[0].max[2] 1000000
execute store result storage iris_rempot:data Shape[0].max[2] double 0.000001 run scoreboard players operation $max_z iris_rempot += $z_offset iris_rempot
