#> iris_rempot:get_hitbox/entity
#
# Returns the shape of the executing entity
#
# @within iris_rempot:raycast/test_for_entity
# @writes
#	storage iris_rempot:data Shape: compound[]
#       A list of cuboids given by two corners in the format {min: [x, y, z], max: [x, y z]}

# Get entity dimensions
scoreboard players set $entity_found iris_rempot 0
execute if score $entity_found iris_rempot matches 0 if entity @s[type=#iris_rempot:tree/0] run function iris_rempot:get_hitbox/entity/tree/0
execute if score $entity_found iris_rempot matches 0 if entity @s[type=#iris_rempot:tree/1] run function iris_rempot:get_hitbox/entity/tree/1
execute if score $entity_found iris_rempot matches 0 if entity @s[type=#iris_rempot:tree/2] run function iris_rempot:get_hitbox/entity/tree/2
execute if score $entity_found iris_rempot matches 0 if entity @s[type=#iris_rempot:tree/3] run function iris_rempot:get_hitbox/entity/tree/3
execute if score $entity_found iris_rempot matches 0 if entity @s[type=#iris_rempot:tree/4] run function iris_rempot:get_hitbox/entity/tree/4
execute if score $entity_found iris_rempot matches 0 if entity @s[type=#iris_rempot:tree/5] run function iris_rempot:get_hitbox/entity/tree/5

# Scale
function iris_rempot:get_hitbox/entity/scale
execute if predicate iris_rempot:baby run scoreboard players operation $entity_width iris_rempot /= $2 iris_rempot
execute if predicate iris_rempot:baby run scoreboard players operation $entity_height iris_rempot /= $2 iris_rempot

# Get the entity's coordinates
scoreboard players operation $entity_[x] iris_rempot = $[x] iris_rempot
scoreboard players operation $entity_[y] iris_rempot = $[y] iris_rempot
scoreboard players operation $entity_[z] iris_rempot = $[z] iris_rempot
scoreboard players operation $entity_{x} iris_rempot = ${x} iris_rempot
scoreboard players operation $entity_{y} iris_rempot = ${y} iris_rempot
scoreboard players operation $entity_{z} iris_rempot = ${z} iris_rempot
execute at @s summon minecraft:marker run function iris_rempot:get_position/get_coordinates
scoreboard players operation $entity_[x] iris_rempot >< $[x] iris_rempot
scoreboard players operation $entity_[y] iris_rempot >< $[y] iris_rempot
scoreboard players operation $entity_[z] iris_rempot >< $[z] iris_rempot
scoreboard players operation $entity_{x} iris_rempot >< ${x} iris_rempot
scoreboard players operation $entity_{y} iris_rempot >< ${y} iris_rempot
scoreboard players operation $entity_{z} iris_rempot >< ${z} iris_rempot

# Save how many blocks away the entity is from the block origin
scoreboard players operation $entity_dx iris_rempot = $entity_[x] iris_rempot
scoreboard players operation $entity_dx iris_rempot -= $[x] iris_rempot
scoreboard players operation $entity_dx iris_rempot *= $1000000 iris_rempot
scoreboard players operation $entity_dx iris_rempot += $entity_{x} iris_rempot
scoreboard players operation $entity_dy iris_rempot = $entity_[y] iris_rempot
scoreboard players operation $entity_dy iris_rempot -= $[y] iris_rempot
scoreboard players operation $entity_dy iris_rempot *= $1000000 iris_rempot
scoreboard players operation $entity_dy iris_rempot += $entity_{y} iris_rempot
scoreboard players operation $entity_dz iris_rempot = $entity_[z] iris_rempot
scoreboard players operation $entity_dz iris_rempot -= $[z] iris_rempot
scoreboard players operation $entity_dz iris_rempot *= $1000000 iris_rempot
scoreboard players operation $entity_dz iris_rempot += $entity_{z} iris_rempot

# Get the coordinates of the bounding box
scoreboard players operation $entity_half_width iris_rempot = $entity_width iris_rempot
scoreboard players operation $entity_half_width iris_rempot /= $2 iris_rempot
scoreboard players operation $entity_x0 iris_rempot = $entity_dx iris_rempot
scoreboard players operation $entity_x0 iris_rempot -= $entity_half_width iris_rempot
execute if score $entity_x0 iris_rempot matches ..0 run scoreboard players set $entity_x0 iris_rempot 0
scoreboard players operation $entity_y0 iris_rempot = $entity_dy iris_rempot
execute if score $entity_y0 iris_rempot matches ..0 run scoreboard players set $entity_y0 iris_rempot 0
scoreboard players operation $entity_z0 iris_rempot = $entity_dz iris_rempot
scoreboard players operation $entity_z0 iris_rempot -= $entity_half_width iris_rempot
execute if score $entity_z0 iris_rempot matches ..0 run scoreboard players set $entity_z0 iris_rempot 0
scoreboard players operation $entity_x1 iris_rempot = $entity_dx iris_rempot
scoreboard players operation $entity_x1 iris_rempot += $entity_half_width iris_rempot
execute if score $entity_x1 iris_rempot matches 1000000.. run scoreboard players set $entity_x1 iris_rempot 1000000
scoreboard players operation $entity_y1 iris_rempot = $entity_dy iris_rempot
scoreboard players operation $entity_y1 iris_rempot += $entity_height iris_rempot
execute if score $entity_y1 iris_rempot matches 1000000.. run scoreboard players set $entity_y1 iris_rempot 1000000
scoreboard players operation $entity_z1 iris_rempot = $entity_dz iris_rempot
scoreboard players operation $entity_z1 iris_rempot += $entity_half_width iris_rempot
execute if score $entity_z1 iris_rempot matches 1000000.. run scoreboard players set $entity_z1 iris_rempot 1000000

# Store these coordinates to storage
data modify storage iris_rempot:data Shape append value {type: "ENTITY", min: [0.0, 0.0, 0.0], max: [0.0, 0.0, 0.0]}
execute store result storage iris_rempot:data Shape[-1].min[0] double 0.000001 run scoreboard players get $entity_x0 iris_rempot
execute store result storage iris_rempot:data Shape[-1].min[1] double 0.000001 run scoreboard players get $entity_y0 iris_rempot
execute store result storage iris_rempot:data Shape[-1].min[2] double 0.000001 run scoreboard players get $entity_z0 iris_rempot
execute store result storage iris_rempot:data Shape[-1].max[0] double 0.000001 run scoreboard players get $entity_x1 iris_rempot
execute store result storage iris_rempot:data Shape[-1].max[1] double 0.000001 run scoreboard players get $entity_y1 iris_rempot
execute store result storage iris_rempot:data Shape[-1].max[2] double 0.000001 run scoreboard players get $entity_z1 iris_rempot

# Special case for item frames and paintings which are annoying
execute if score $entity_found iris_rempot matches 0 store success score $entity_found iris_rempot store success score $entity.is_item_frame iris_rempot if entity @s[type=#iris_rempot:item_frames]
execute if score $entity.is_item_frame iris_rempot matches 1 run function iris_rempot:get_hitbox/entity/item_frame

# Give this entity a tag and an ID, and store the ID in the hitbox
tag @s add iris_rempot.possible_target
scoreboard players operation @s iris_rempot.id = $max_entity_id iris_rempot.id
execute store result storage iris_rempot:data Shape[-1].entity_id int 1 run scoreboard players get @s iris_rempot.id
scoreboard players add $max_entity_id iris_rempot.id 1
