#> iris_rempot:get_position/main
#
# Gets the current coordinates and rotation.
# Coordinates are returned as a triplet of integer coordinates and a triplet of fractional coordinates.
# Rotation is returned as a steering vector of magnitude 1000000.
#
# @context a marker
# @within iris_rempot:get_target
# @within iris_rempot:get_hitbox/entity
# @writes
#    score $[x] iris_rempot
#        The integer x coordinate of the current position
#    score $[y] iris_rempot
#        The integer y coordinate of the current position
#    score $[z] iris_rempot
#        The integer z coordinate of the current position
#    score ${x} iris_rempot
#        The fractional x coordinate of the current position, represented by an integer between 0 and 1000000
#    score ${y} iris_rempot
#        The fractional y coordinate of the current position, represented by an integer between 0 and 1000000
#    score ${z} iris_rempot
#        The fractional z coordinate of the current position, represented by an integer between 0 and 1000000
#    score $dx iris_rempot
#        The x coordinate of the steering vector of the ray, represented by an integer between -1000000 and 1000000
#    score $dy iris_rempot
#        The y coordinate of the steering vector of the ray, represented by an integer between -1000000 and 1000000
#    score #dz iris_rempot
#        The z coordinate of the steering vector of the ray, represented by an integer between -1000000 and 1000000

function iris_rempot:get_position/get_coordinates
function iris_rempot:get_position/get_rotation
