#> iris_rempot:raycast/check_intersection/loop
#
# Tests for ray-box intersections with all axis-aligned bounding boxes of a hitbox
#
# @reads
#   storage iris_rempot:data Shape
#       A list of axis-aligned bounding boxes of the form {min: [x, y, z], max: [x, y, z]}
# @output
#   Success: 1 if a box is hit, 0 otherwise
#   Result: the distance to the first box that is hit
# @private
# @within iris_rempot:raycast/test_for_block
# @within iris_rempot:raycast/test_for_entity
# @within iris_rempot:raycast/check_intersection/loop

# Test for intersection with a single bounding box
data modify storage iris_rempot:data Box set from storage iris_rempot:data Shape[-1]
data remove storage iris_rempot:data Shape[-1]
execute store success score $is_hit iris_rempot store result score $distance iris_rempot run function iris_rempot:raycast/check_intersection/ray_box

# If this box is indeed hit before any other this far, remember the targeted box and the targeted face
execute if score $is_hit iris_rempot matches 1 if score $distance iris_rempot >= $min_distance iris_rempot run scoreboard players set $is_hit iris_rempot 0
execute if score $is_hit iris_rempot matches 1 run data modify storage iris_rempot:data TargetedBox set from storage iris_rempot:data Box
execute if score $is_hit iris_rempot matches 1 if score $hits_x_face iris_rempot matches 1 if score $to_aabb iris_rempot = $to_x_face iris_rempot run data modify storage iris_rempot:data TargetedFace set from storage iris_rempot:data Faces[0]
execute if score $is_hit iris_rempot matches 1 if score $hits_y_face iris_rempot matches 1 if score $to_aabb iris_rempot = $to_y_face iris_rempot run data modify storage iris_rempot:data TargetedFace set from storage iris_rempot:data Faces[1]
execute if score $is_hit iris_rempot matches 1 if score $hits_z_face iris_rempot matches 1 if score $to_aabb iris_rempot = $to_z_face iris_rempot run data modify storage iris_rempot:data TargetedFace set from storage iris_rempot:data Faces[2]
execute if score $is_hit iris_rempot matches 1 run scoreboard players operation $min_distance iris_rempot = $distance iris_rempot

# Loop this function until all boxes have been analyzed
execute if data storage iris_rempot:data Shape[-1] run return run function iris_rempot:raycast/check_intersection/loop
execute if score $min_distance iris_rempot matches 2147483647 run return fail
scoreboard players operation $min_distance iris_rempot *= $1000 iris_rempot
return run scoreboard players get $min_distance iris_rempot
