#> iris_rempot:raycast/find_next_block
#
# Find the coordinates of the next tile that should be traversed by the ray
#
# @private
# @within iris_rempot:raycast/loop
# @writes
#   scores $[x] $[y] $[z] iris_rempot
#       The new position
#   scores $last_[x] $last_[y] $last_[z] iris_rempot
#       The previous position
# @output
#   Result: The distance to the next block
#   Success: 1

# Save previous coordinates
scoreboard players operation $last_[x] iris_rempot = $[x] iris_rempot
scoreboard players operation $last_[y] iris_rempot = $[y] iris_rempot
scoreboard players operation $last_[z] iris_rempot = $[z] iris_rempot

# See what distance the ray needs to travel to hit another tile with a different x coordinate
execute if score $dx iris_rempot matches 0.. run scoreboard players set $to_next_x iris_rempot 1000000000
execute if score $dx iris_rempot matches ..-1 run scoreboard players set $to_next_x iris_rempot 0
scoreboard players operation ${x}*1000 iris_rempot = ${x} iris_rempot
scoreboard players operation ${x}*1000 iris_rempot *= $1000 iris_rempot
scoreboard players operation $to_next_x iris_rempot -= ${x}*1000 iris_rempot
scoreboard players operation $to_next_x iris_rempot /= $dx iris_rempot

# See what distance the ray needs to travel to hit another tile with a different y coordinate
execute if score $dy iris_rempot matches 0.. run scoreboard players set $to_next_y iris_rempot 1000000000
execute if score $dy iris_rempot matches ..-1 run scoreboard players set $to_next_y iris_rempot 0
scoreboard players operation ${y}*1000 iris_rempot = ${y} iris_rempot
scoreboard players operation ${y}*1000 iris_rempot *= $1000 iris_rempot
scoreboard players operation $to_next_y iris_rempot -= ${y}*1000 iris_rempot
scoreboard players operation $to_next_y iris_rempot /= $dy iris_rempot

# See what distance the ray needs to travel to hit another tile with a different z coordinate
execute if score $dz iris_rempot matches 0.. run scoreboard players set $to_next_z iris_rempot 1000000000
execute if score $dz iris_rempot matches ..-1 run scoreboard players set $to_next_z iris_rempot 0
scoreboard players operation ${z}*1000 iris_rempot = ${z} iris_rempot
scoreboard players operation ${z}*1000 iris_rempot *= $1000 iris_rempot
scoreboard players operation $to_next_z iris_rempot -= ${z}*1000 iris_rempot
scoreboard players operation $to_next_z iris_rempot /= $dz iris_rempot

# Determine which distance is the shortest
execute if score $to_next_x iris_rempot <= $to_next_y iris_rempot if score $to_next_x iris_rempot <= $to_next_z iris_rempot run data merge storage iris_rempot:data {NextCoordinateChange: "x"}
execute if score $to_next_y iris_rempot <= $to_next_x iris_rempot if score $to_next_y iris_rempot <= $to_next_z iris_rempot run data merge storage iris_rempot:data {NextCoordinateChange: "y"}
execute if score $to_next_z iris_rempot <= $to_next_x iris_rempot if score $to_next_z iris_rempot <= $to_next_y iris_rempot run data merge storage iris_rempot:data {NextCoordinateChange: "z"}

# Calculate the new coordinates when the ray reaches the next tile
execute if data storage iris_rempot:data {NextCoordinateChange: "x"} run data modify storage iris_rempot:args {} merge value {a: "x", b: "y", c: "z"}
execute if data storage iris_rempot:data {NextCoordinateChange: "y"} run data modify storage iris_rempot:args {} merge value {a: "y", b: "z", c: "x"}
execute if data storage iris_rempot:data {NextCoordinateChange: "z"} run data modify storage iris_rempot:args {} merge value {a: "z", b: "x", c: "y"}
function iris_rempot:raycast/macro_functions/find_next_block_aux with storage iris_rempot:args

# Return the added distance
return run scoreboard players operation $to_next_block iris_rempot *= $1000 iris_rempot
