#> iris_rempot:raycast/loop
#
# Loops forward until an obstacle is hit or until the maximum recursion depth has been reached
#
# @context a marker and the current ray position
# @within iris_rempot:get_target
# @within iris_rempot:raycast/loop

# Test for collisions
execute store success score $block_hit iris_rempot store result score $block_distance iris_rempot run function iris_rempot:raycast/test_for_block
execute store success score $entity_hit iris_rempot store result score $entity_distance iris_rempot run function iris_rempot:raycast/test_for_entity
execute if score $block_hit iris_rempot matches 1 run return run function iris_rempot:raycast/on_hit
execute if score $entity_hit iris_rempot matches 1 run return run function iris_rempot:raycast/on_hit

# Proceed to the next block
execute store result score $to_next_block iris_rempot run function iris_rempot:raycast/find_next_block
scoreboard players operation $total_distance iris_rempot += $to_next_block iris_rempot

# Fail if the maximum recursion depth is reached and nothing was found
scoreboard players add $depth iris_rempot 1
execute if score $depth iris_rempot = $max_depth iris_rempot run tag @s remove iris_rempot.executing
execute if score $depth iris_rempot = $max_depth iris_rempot run return fail

# Otherwise, loop this function at the next block
execute if data storage iris_rempot:data {NextCoordinateChange: "x"} if score $dx iris_rempot matches 0.. positioned ~1 ~ ~ run return run function iris_rempot:raycast/loop
execute if data storage iris_rempot:data {NextCoordinateChange: "x"} if score $dx iris_rempot matches ..-1 positioned ~-1 ~ ~ run return run function iris_rempot:raycast/loop
execute if data storage iris_rempot:data {NextCoordinateChange: "y"} if score $dy iris_rempot matches 0.. positioned ~ ~1 ~ run return run function iris_rempot:raycast/loop
execute if data storage iris_rempot:data {NextCoordinateChange: "y"} if score $dy iris_rempot matches ..-1 positioned ~ ~-1 ~ run return run function iris_rempot:raycast/loop
execute if data storage iris_rempot:data {NextCoordinateChange: "z"} if score $dz iris_rempot matches 0.. positioned ~ ~ ~1 run return run function iris_rempot:raycast/loop
execute if data storage iris_rempot:data {NextCoordinateChange: "z"} if score $dz iris_rempot matches ..-1 positioned ~ ~ ~-1 run return run function iris_rempot:raycast/loop
execute if score $depth iris_rempot < $max_depth iris_rempot at @s run return run function iris_rempot:raycast/loop
