#> iris_rempot:raycast/find_next_block_aux
#
# Auxiliary command for running macros from find_next_block
# Note: because there are only three possible input value combinations, they should all be cached and so the overhead from runtime compilation of macro lines should be minimal
#
# @input
#   a: The axis along which we are moving (for example, if the ray moves one tile up, this is 'y'). One of 'x', 'y', or 'z'.
#   b: Another axis. One of 'x', 'y', or 'z'.
#   c: The third axis. One of 'x', 'y', or 'z'.

$scoreboard players operation $to_next_block iris_rempot = $to_next_$(a) iris_rempot

# Find the exact position of the ray when it leaves the current tile
$execute if score $d$(a) iris_rempot matches 0.. run scoreboard players add $[$(a)] iris_rempot 1
$execute if score $d$(a) iris_rempot matches 0.. run scoreboard players set ${$(a)} iris_rempot 0
$execute if score $d$(a) iris_rempot matches ..-1 run scoreboard players remove $[$(a)] iris_rempot 1
$execute if score $d$(a) iris_rempot matches ..-1 run scoreboard players set ${$(a)} iris_rempot 1000000

# Calculate new position on the second axis
scoreboard players operation $delta iris_rempot = $to_next_block iris_rempot
$scoreboard players operation $delta iris_rempot *= $d$(b) iris_rempot
scoreboard players operation $delta iris_rempot /= $1000 iris_rempot
$scoreboard players operation ${$(b)} iris_rempot += $delta iris_rempot

# Calculate new position on the third axis
scoreboard players operation $delta iris_rempot = $to_next_block iris_rempot
$scoreboard players operation $delta iris_rempot *= $d$(c) iris_rempot
scoreboard players operation $delta iris_rempot /= $1000 iris_rempot
$scoreboard players operation ${$(c)} iris_rempot += $delta iris_rempot
