#> iris_rempot:raycast/on_hit
#
# Writes all available information about the encountered block or entity
# See iris_rempot:get_target for full documentation
#
# @private
# @within iris_rempot:raycast/loop

# Write target type (one of BLOCK, ENTITY)
execute if score $block_hit iris_rempot matches 1 if score $entity_hit iris_rempot matches 0 run data modify storage iris_rempot:output TargetType set value "BLOCK"
execute if score $entity_hit iris_rempot matches 1 if score $block_hit iris_rempot matches 0 run data modify storage iris_rempot:output TargetType set value "ENTITY"
execute if score $block_hit iris_rempot matches 1 if score $entity_hit iris_rempot matches 1 if score $block_distance iris_rempot <= $entity_distance iris_rempot run data modify storage iris_rempot:output TargetType set value "BLOCK"
execute if score $block_hit iris_rempot matches 1 if score $entity_hit iris_rempot matches 1 if score $block_distance iris_rempot > $entity_distance iris_rempot run data modify storage iris_rempot:output TargetType set value "ENTITY"

# Write targeted block
execute if data storage iris_rempot:output {TargetType: "BLOCK"} run data modify storage iris_rempot:output TargetedBlock set value [0, 0, 0]
execute if data storage iris_rempot:output {TargetType: "BLOCK"} store result storage iris_rempot:output TargetedBlock[0] int 1 run scoreboard players get $[x] iris_rempot
execute if data storage iris_rempot:output {TargetType: "BLOCK"} store result storage iris_rempot:output TargetedBlock[1] int 1 run scoreboard players get $[y] iris_rempot
execute if data storage iris_rempot:output {TargetType: "BLOCK"} store result storage iris_rempot:output TargetedBlock[2] int 1 run scoreboard players get $[z] iris_rempot
execute if data storage iris_rempot:output {TargetType: "BLOCK"} align xyz run summon minecraft:marker ~0.5 ~0.5 ~0.5 {Tags: ["iris_rempot", "iris_rempot.targeted_block"]}

# Write targeted entity
execute if data storage iris_rempot:output {TargetType: "ENTITY"} run data modify storage iris_rempot:output TargetedEntity set from storage iris_rempot:data TargetedBox.entity_id
execute if data storage iris_rempot:output {TargetType: "ENTITY"} run data remove storage iris_rempot:data TargetedBox.entity_id
execute if data storage iris_rempot:output {TargetType: "ENTITY"} run data remove storage iris_rempot:data TargetedFace.entity_id
execute if data storage iris_rempot:output {TargetType: "ENTITY"} store result score $entity_id iris_rempot run data get storage iris_rempot:output TargetedEntity
execute if data storage iris_rempot:output {TargetType: "ENTITY"} as @e[tag=iris_rempot.possible_target] if score @s iris_rempot.id = $entity_id iris_rempot run tag @s add iris_rempot.targeted_entity
execute if data storage iris_rempot:output {TargetType: "ENTITY"} run tag @e remove iris_rempot.possible_target

# Write target position
data modify storage iris_rempot:output TargetPosition.tile set value [0, 0, 0]
execute store result storage iris_rempot:output TargetPosition.tile[0] int 1 run scoreboard players get $[x] iris_rempot
execute store result storage iris_rempot:output TargetPosition.tile[1] int 1 run scoreboard players get $[y] iris_rempot
execute store result storage iris_rempot:output TargetPosition.tile[2] int 1 run scoreboard players get $[z] iris_rempot
data modify storage iris_rempot:output TargetPosition.point set from storage iris_rempot:data TargetPoint
execute store result score ${x} iris_rempot run data get storage iris_rempot:output TargetPosition.point[0] 1000000
execute store result score ${y} iris_rempot run data get storage iris_rempot:output TargetPosition.point[1] 1000000
execute store result score ${z} iris_rempot run data get storage iris_rempot:output TargetPosition.point[2] 1000000

# Write targeted box
data modify storage iris_rempot:output TargetedBox set from storage iris_rempot:data TargetedBox

# Write targeted face
data modify storage iris_rempot:output TargetedFace set from storage iris_rempot:data TargetedFace
execute if data storage iris_rempot:output TargetedFace{Direction: "WEST_EAST"} if score $dx iris_rempot matches 0.. run data modify storage iris_rempot:output TargetedFace.Direction set value "WEST"
execute if data storage iris_rempot:output TargetedFace{Direction: "WEST_EAST"} if score $dx iris_rempot matches ..-1 run data modify storage iris_rempot:output TargetedFace.Direction set value "EAST"
execute if data storage iris_rempot:output TargetedFace{Direction: "UP_DOWN"} if score $dy iris_rempot matches 0.. run data modify storage iris_rempot:output TargetedFace.Direction set value "DOWN"
execute if data storage iris_rempot:output TargetedFace{Direction: "UP_DOWN"} if score $dy iris_rempot matches ..-1 run data modify storage iris_rempot:output TargetedFace.Direction set value "UP"
execute if data storage iris_rempot:output TargetedFace{Direction: "NORTH_SOUTH"} if score $dz iris_rempot matches 0.. run data modify storage iris_rempot:output TargetedFace.Direction set value "NORTH"
execute if data storage iris_rempot:output TargetedFace{Direction: "NORTH_SOUTH"} if score $dz iris_rempot matches ..-1 run data modify storage iris_rempot:output TargetedFace.Direction set value "SOUTH"

# Write total distance
execute if data storage iris_rempot:output {TargetType: "BLOCK"} run scoreboard players operation $total_distance iris_rempot += $block_distance iris_rempot
execute if data storage iris_rempot:output {TargetType: "ENTITY"} run scoreboard players operation $total_distance iris_rempot += $entity_distance iris_rempot
execute store result storage iris_rempot:output Distance double 0.000001 run scoreboard players get $total_distance iris_rempot

# Run callback
execute if data storage iris_rempot:settings Callback run data modify storage iris_rempot:args function set from storage iris_rempot:settings Callback
execute if data storage iris_rempot:settings Callback run function iris_rempot:raycast/macro_functions/callback with storage iris_rempot:args

return run scoreboard players get $total_distance iris_rempot
