#> iris_rempot:set_coordinates
#
# Teleports the executing entity at a given position from six scores.
# Meant to be executed as the ray marker after raycasting, scores are then set to the player's targeted position:
#    execute as @p at @s anchored eyes positioned ^ ^ ^ run function iris_rempot:get_target
#    execute as @e[type=minecraft:marker, tag=iris_rempot.ray] run function iris_rempot:set_coordinates
#
# @public
# @context any entity
# @input
#   score $[x] iris_rempot
#       The integer value of the new X position
#   score ${x} iris_rempot
#       The fractional value of the new X position, as a number between 0 and 1000000

execute unless entity @s run return fail

# Clamp to 0..999999
execute if score ${x} iris_rempot matches ..0 run scoreboard players set ${x} iris_rempot 0
execute if score ${y} iris_rempot matches ..0 run scoreboard players set ${y} iris_rempot 0
execute if score ${z} iris_rempot matches ..0 run scoreboard players set ${z} iris_rempot 0
execute if score ${x} iris_rempot matches 1000000.. run scoreboard players set ${x} iris_rempot 999999
execute if score ${y} iris_rempot matches 1000000.. run scoreboard players set ${y} iris_rempot 999999
execute if score ${z} iris_rempot matches 1000000.. run scoreboard players set ${z} iris_rempot 999999

# Get integer coordinates for the first teleport command (absolute coordinates)
execute store result storage iris_rempot:args x int 1 run scoreboard players get $[x] iris_rempot
execute store result storage iris_rempot:args y int 1 run scoreboard players get $[y] iris_rempot
execute store result storage iris_rempot:args z int 1 run scoreboard players get $[z] iris_rempot

# Get fractional coordinates for the second teleport command (relative coordinates)
execute store result storage iris_rempot:args value int 1 run scoreboard players get ${x} iris_rempot
function iris_rempot:set_coordinates/pad_with_zeros with storage iris_rempot:args
data modify storage iris_rempot:args dx set string storage iris_rempot:data String -6

execute store result storage iris_rempot:args value int 1 run scoreboard players get ${y} iris_rempot
function iris_rempot:set_coordinates/pad_with_zeros with storage iris_rempot:args
data modify storage iris_rempot:args dy set string storage iris_rempot:data String -6

execute store result storage iris_rempot:args value int 1 run scoreboard players get ${z} iris_rempot
function iris_rempot:set_coordinates/pad_with_zeros with storage iris_rempot:args
data modify storage iris_rempot:args dz set string storage iris_rempot:data String -6

# Generate the two teleport commands
function iris_rempot:set_coordinates/teleport with storage iris_rempot:args
